// File: plum.java
// Producer-consumer problem
//	One producer, many consumers


public class plum 
{
  public static void main(String args[]) 
  {  int numCons,numProd;
     // Check
     if (args.length!=1) {
	System.err.println("Usage:  java plum <#consumers>");
  	System.exit(-1);
     }
     int num=0;
     try {
	num=Integer.parseInt(args[0]);
     }
     catch (Exception e) {
	System.err.println(e);
	System.exit(-2);
     }
  
     Producer p = new Producer();
     p.start();
     
     Consumer c[] = new Consumer[num];
     for (int nc=0;nc<num;nc++) {
	c[nc]=new Consumer(nc,p);
	c[nc].start();
     }

  }
}


///////////////////////////////////////////

class Producer extends Thread 
{   // Data area
    private String [] buffer = new String [8];
    private int pi = 0;  // produce index
    private int gi = 0;  // get index
 
    public void run() 
    {
       // just keep producing
       for(;;) produce();
    }
 
    private final long start = System.currentTimeMillis();
    private final String banana() 
    {
        return "" + (int) (System.currentTimeMillis() - start);
    }
 
    private synchronized void produce() 
    {
       // the producer itself calls this to fill the buffer

       // while there isn't room in the buffer
       while ( pi-gi+1 > buffer.length ) 
       {
           try {
		wait();
	   } 
	   catch(Exception e) {}
       } 
       buffer[pi&0x7] = banana();      // pi&0x7 (logical and) ==>  producer index % 7
       System.out.println("produced["+(pi&7)+"] " + buffer[pi&7]);
       pi++;
       // Everybody can have a try
       notifyAll();
    }
 
    // Let the Consumer access data
    public synchronized String call_me_to_consume()
    {
       // a consumer calls this to get something from the buffer

       // while there's nothing left to take from the buffer
       while (pi==gi) 
       {
           try {
	     wait();
	   } 
	   catch(Exception e) {}
       } 
       notifyAll();
       return buffer[ gi++&0x7 ];   // gi % 7 is index, then gi++
    }
}

///////////////////////////////////////////

class Consumer extends Thread 
{
   int i;  // consumer's number
   Producer myProducer;

   public Consumer(int n,  Producer who) 
   { i = n; 
     myProducer = who; 
   }
 
   public void run() 
   {
      java.util.Random r = new java.util.Random();
      for(;;)   // endless
      {   // Grab something
          String result = myProducer.call_me_to_consume();
	  // Print it
          System.out.println("Consumer " + i + " consumed: "+result);
          // next line is just to make it run a bit slower.
          int randomtime = Math.abs( r.nextInt() ) % 250;
          try {
	   sleep(randomtime);
	  } 
	  catch(Exception e){}
      }
   }
}

